#include <bits/stdc++.h>
using namespace std;
#define ll long long
int main()
{
    ll n,q;
    cin >> n >> q;
    ll d[n],p[n],k[q];
    ll uk;
    for(ll i=0;i<n;i++) {
        cin >> d[i];
        cin >> p[i];
    }
    for(ll i=0;i<q;i++)
    {

        cin >> k[i];
    }
     for(ll j=0;j<q;j++) {
            uk=0;
    for(ll i=0;i<n;i++)
    {
        if(k[j]<d[i]) {
            break;
        }
        uk+=min(k[j]-d[i]+1,p[i]);
    }
        cout << uk << endl;
        }


    return 0;
}